package com.fp.persistence.parmas.soli;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMCABREPDESTRUIRARMAS*/
@Entity(name="TarmCabRepDestruirArmas")
@Table(name="TARMCABREPDESTRUIRARMAS")
public class TarmCabRepDestruirArmas extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmCabRepDestruirArmas
*/
@Id
@Column(name="CREPORTE" ,nullable=false, updatable=false)
private Integer pk;
@Column(name="FREPORTE", nullable=true)

/**
* Fecha de generacion del reporte
*/
private Date freporte;

@Column(name="OBSJEFEDPTO", nullable=true)

/**
* OBSERVACIONES GENERADAS POR EL JEFE DE DPTO
*/
private String obsjefedpto;

@Column(name="OBSJEFECC", nullable=true)

/**
* OBSERVACIONES GENERADAS POR EL JEFE DEL COMANDO CONJUNTO
*/
private String obsjefecc;

@Column(name="XPATH", nullable=true)

/**
* null
*/
private String xpath;

/**Contructor por defecto*/
public TarmCabRepDestruirArmas(){
}
/**Contructor de TarmCabRepDestruirArmas
@param pPk Clave Primaria del entity
*/
public TarmCabRepDestruirArmas(Integer pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmCabRepDestruirArmas
*/
public static TarmCabRepDestruirArmas find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmCabRepDestruirArmas obj = pEntityManager.find(TarmCabRepDestruirArmas.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmCabRepDestruirArmas
@return El objeto que referencia a la Clave primaria de TarmCabRepDestruirArmas
*/
public Integer getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmCabRepDestruirArmas
@param pPk El objeto que referencia a la nueva Clave primaria de TarmCabRepDestruirArmas
*/
public void setPk(Integer pPk){
  pk=pPk;
}
/**Obtiene el valor de freporte
@return valor de freporte*/
public Date getFreporte(){
  return freporte;
}
/**Fija el valor de freporte
@param pFreporte nuevo Valor de freporte*/
public void setFreporte(Date pFreporte){
  freporte=pFreporte;
}

/**Obtiene el valor de obsjefedpto
@return valor de obsjefedpto*/
public String getObsjefedpto(){
  return obsjefedpto;
}
/**Fija el valor de obsjefedpto
@param pObsjefedpto nuevo Valor de obsjefedpto*/
public void setObsjefedpto(String pObsjefedpto){
  obsjefedpto=pObsjefedpto;
}

/**Obtiene el valor de obsjefecc
@return valor de obsjefecc*/
public String getObsjefecc(){
  return obsjefecc;
}
/**Fija el valor de obsjefecc
@param pObsjefecc nuevo Valor de obsjefecc*/
public void setObsjefecc(String pObsjefecc){
  obsjefecc=pObsjefecc;
}

/**Obtiene el valor de xpath
@return valor de xpath*/
public String getXpath(){
  return xpath;
}
/**Fija el valor de xpath
@param pXpath nuevo Valor de xpath*/
public void setXpath(String pXpath){
  xpath=pXpath;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmCabRepDestruirArmas))return false;
    TarmCabRepDestruirArmas that = (TarmCabRepDestruirArmas) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmCabRepDestruirArmas
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmCabRepDestruirArmas
*/
public Object createInstance(){
 TarmCabRepDestruirArmas instance=new TarmCabRepDestruirArmas();	
 return instance;
}
/**Clona la entidad TarmCabRepDestruirArmas
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmCabRepDestruirArmas p=(TarmCabRepDestruirArmas)this.clone();
  return p;
}
}
